#include <sys/types.h>
#include <limits.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <rpm/rpmts.h>
#include <rpm/rpmdb.h>
#include <rpm/rpmmacro.h>

int
main(int argc, char **argv)
{
  int ret = 0;
  rpmts ts;

  rpmDefineMacro(NULL, "_dbpath /var/lib/rpm", 0);
  ts = rpmtsCreate();
  if (!ts)
    {
      fprintf(stderr, "rpmtsCreate failed\n");
      exit(1);
    }
  if (rpmtsOpenDB(ts, O_RDONLY))
    {
      perror("rpmtsOpenDB");
      exit(1);
    }
  if (argc <= 1)
    {
      rpmdbIndexIterator ii;
      ii = rpmdbIndexIteratorInit(rpmtsGetRdb(ts), RPMDBI_NAME);
      if (ii)
	{
	  const void *key = 0;
          size_t keylen = 0;
	  while ((rpmdbIndexIteratorNext(ii, &key, &keylen)) == 0)
	    printf("%*.*s\n", (int)keylen, (int)keylen, (char *)key);
	}
      rpmdbIndexIteratorFree(ii);
    }
  else
    {
      argc--;
      while (argc--)
	{
          rpmdbMatchIterator mi;
	  argv++;
          mi = rpmdbInitIterator(rpmtsGetRdb(ts), RPMDBI_NAME, (void *)*argv, strlen(*argv));
	  if (mi && rpmdbGetIteratorCount(mi))
	    printf("%s\n", *argv);
          else
	    ret = 1;
	  rpmdbFreeIterator(mi);
        }
    }
  rpmtsFree(ts);
  return ret;
}
